//+------------------------------------------------------------------+
//|                                                       Second.mq4 |
//|                                                           Cooter |
//|                                                  Cooter@inbox.ru |
//+------------------------------------------------------------------+
//+-------------------------------------------------------------------------+
//|  :                                                   |
//| 1.   ,      (  ),     |
//|        .                                |
//| 2.     .                             |
//| 3.      .                            |
//| 4.    .                                              |
//|    EurUsd UsdChf GbfUsd UsdJpy 4           |
//|      2004.01.01  2007.01.01               |
//|      2007.01.01  2008.06.01  |
//|      GbpUsd  EurUsd                    |
//+-------------------------------------------------------------------------+ 
#property copyright "Cooter"
#property link      "Cooter@inbox.ru"

//---- input parameters
extern int       SL1=40;// StopLoss    BuyStop        
extern int       SL2=830;// StopLoss    SellStop        
extern int       TP1=670;// TakeProfit    BuyStop        
extern int       SB1=60;// BuyStop    BuyStop        
extern int       SS1=200;// SellStop    SellStop        
extern int       TP2=980;// TakeProfit    SellStop        
extern int       SB2=90;// StopBuy    StopBuy        
extern int       SS2=200;// StopSell    StopSell        
extern int       TS=130;//    StopLoss
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|          |
//+------------------------------------------------------------------+
bool isNewBar(int timeFrame)
   {
   bool res=false;
   
   //      () 
   //  7 () 
   static datetime _sTime[7];  
   int i=6;
 
   switch (timeFrame) 
      {
      case 1  : i=0; break;
      case 5  : i=2; break;
      case 15 : i=3; break;
      case 30 : i=4; break;
      case 60 : i=5; break;
      case 240: i=6; break;
      case 1440: i=7; break;
      default:  timeFrame = 1440;
      }
//----
   if (_sTime[i]==0 || _sTime[i]!=iTime(Symbol(),timeFrame,0))
      {
      _sTime[i] = iTime(Symbol(),timeFrame,0);
      res=true;
      }
      
//----
   return(res);   
   }
//+---------------------------------------------------------+
//|                                   |
//+---------------------------------------------------------+
int SignalExist()
   {
     int res=0;
     double prisedo=Open[0];
     double priseposle=Open[1];
     double avereagedo=iMA(NULL, 0, 100, 0, MODE_SMA, PRICE_CLOSE, 1);
     double avereageposle=iMA(NULL, 0, 100, 0, MODE_SMA, PRICE_CLOSE, 0);
     if ((prisedo>avereagedo)&&(priseposle<avereageposle)) res=1; //          
     if ((prisedo<avereagedo)&&(priseposle>avereageposle)) res=2; //        
   return(res);
   }
//+-----------------------------------------------------------------------------------+
//|  ,         |
//+-----------------------------------------------------------------------------------+
int GetOrder(int val)
   {
      if (val==1)
      {
         OrderSend(Symbol(),OP_BUYSTOP,1,Ask+SB1*Point,3,Ask-SL1*Point,Ask+TP1*Point,"fuck buy",0,0,Green);
         OrderSend(Symbol(),OP_SELLSTOP,1,Bid-SS1*Point,3,Bid+SL2*Point,Bid-TP2*Point,"fuck sell",0,0,Green);
      }
      if (val==2)
      {
         OrderSend(Symbol(),OP_BUYSTOP,1,Ask+SB2*Point,3,Ask-SL1*Point,Ask+TP1*Point,"fuck buy",0,0,Green);
         OrderSend(Symbol(),OP_SELLSTOP,1,Bid-SS2*Point,3,Bid+SL2*Point,Bid-TP2*Point,"fuck sell",0,0,Green);
      }
      return(0);
      
   }
//+--------------------------------+
//|   |
//+--------------------------------+
int CloseOrders()
   {
      int ordertype;
      int total=OrdersTotal();
      int ticket;
      for(int i=total;i>=0;i--)
      {
       if (OrderSelect(i,SELECT_BY_POS))
         {
         ordertype=OrderType();
         ticket=OrderTicket();
         if (ordertype!=0 || ordertype!=1) OrderDelete(ticket);
         }
      }   
      return(0);
   }
//+----------------------------------------------------+
//|       |
//+----------------------------------------------------+
bool Openis()
   {
      bool res=false;
      int total=OrdersTotal();
      int ordertype;
      for(int i=total;i>=0;i--)
      {
       if (OrderSelect(i,SELECT_BY_POS))
         {
         RefreshRates();
         ordertype=OrderType();
         switch(ordertype)
            {
            case 0:
               if (Bid-OrderStopLoss()>TS*Point) OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TS*Point,0,0,Blue);
               res=true;
               break;//    switch    
            case 1:
               if (OrderStopLoss()-Ask>TS*Point) OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TS*Point,0,0,Blue);
               res=true;
               break;
            }
         }
       }
      return(res);
   }  
int start()
  {
//----
      int k=Period();
      if (isNewBar(k))
      {
         if (SignalExist()==1) GetOrder(1);
         if (SignalExist()==2) GetOrder(2);
         if (Openis()) CloseOrders();
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+